#include "delays.h"
#include "types.h"
EE_UINT16 lcd_temp_count = 0;

static myclock sysclk;

void Delay( unsigned int delay_count ) 
{
	lcd_temp_count = delay_count +1;
	asm volatile("outer: dec _lcd_temp_count");	
	asm volatile("cp0 _lcd_temp_count");
	asm volatile("bra z, done");
	asm volatile("do #3200, inner" );	
	asm volatile("nop");
	asm volatile("inner: nop");
	asm volatile("bra outer");
	asm volatile("done:");
}

void Delay_Us( unsigned int delayUs_count )
{
	lcd_temp_count = delayUs_count +1;
	asm volatile("outer1: dec _lcd_temp_count");	
	asm volatile("cp0 _lcd_temp_count");
	asm volatile("bra z, done1");
	asm volatile("do #1500, inner1" );	
	asm volatile("nop");
	asm volatile("inner1: nop");
	asm volatile("bra outer1");
	asm volatile("done1:");
}

void initClk()
{
	sysclk.sec=0;
	sysclk.cent=0;
}

void resetClk(myclock *me)
{
	me->sec=0;
	me->cent=0;
}

void tickClk()
{
	sysclk.cent++;
	if (sysclk.cent == 100) {
		sysclk.sec++;
		sysclk.cent=0;
	}
}

void SetAlarm(myclock *me, int s, int cs)
{
	me->sec = sysclk.sec+s;
	me->cent = sysclk.cent+cs;
}

int  ExpAlarm(myclock *me)
{
	if ((me->sec == 0) && (me->cent == 0)) return 0;
	if ((me->sec < sysclk.sec) || 
	((me->sec == sysclk.sec) && (me->cent < sysclk.cent))) {
		resetClk(me);
		return 1;
	} else
		return 0;
}
